
#include "arch/sys_arch.h"
#include "arch/cc.h"
#include "lwip/sys.h"
#include "lwip/sio.h"

#include <stdarg.h>
//#include <crtdbg.h>

//#include <windows.h>
//#include <Winbase.h>
#include "MVSFORTH.h"

#define	TRACE_TO_STDOUT
//ivv #define	TRACE_TO_FILE
extern int sedi;


///////////////////////////////////////////////////////////////////////////////////////////
//
// DECLARACIONES
//
///////////////////////////////////////////////////////////////////////////////////////////

extern char  bofstdout[];
u32_t g_write(void * fd, u8_t * buffer, u32_t size);

void SleepEx1(int tt,int xx)
{
int zz;
 zz= GetTickCount()+tt;
  do { 	 forth_exec( C_PAUSE );
  }  while(GetTickCount()<zz );

}


u32_t	sJiffies;
#define DWORD unsigned
//ivv
#define CRITICAL_SECTION unsigned

typedef	struct
{
			HANDLE			hThread;
			DWORD			ThreadID;
	struct	sys_timeouts	timeouts;

} t_thread;

typedef	struct
{
	int		hasdata;
	int		nodata;
	void*		value;

} t_mailbox;

t_thread			sThreads[MAX_THREADS];
t_mailbox			sMailboxes[MAX_MAILBOXES];
CRITICAL_SECTION	sSync;
#ifdef TRACE_TO_STDOUT
CRITICAL_SECTION	sOutSync;
#endif
HANDLE				sSIOWriteEvent;
HANDLE				sSIOReadEvent;
#ifdef TRACE_TO_FILE
//ivv FILE*				sDebug;
#endif

///////////////////////////////////////////////////////////////////////////////////////////
//
// INICIALIZACIN Y UTILIDADES
//
///////////////////////////////////////////////////////////////////////////////////////////

/* sys_init() must be called before anthing else. */
void sys_init(void)
{
	sJiffies = GetTickCount();

	memset( &sThreads, 0, sizeof(sThreads) );
	memset( &sMailboxes, 0, sizeof(sMailboxes) );

//	InitializeCriticalSection(&sSync);
#ifdef TRACE_TO_STDOUT
//	InitializeCriticalSection(&sOutSync);
#endif

#ifdef TRACE_TO_FILE
	sDebug = fopen( "ppp_debug.txt", "a" );
	xASSERTE( sDebug != NULL );
#endif

	sThreads[0].ThreadID = GetCurrentThreadId();
// 1111
	sThreads[0].hThread = (HANDLE) 0xccc; //  OpenThread(THREAD_ALL_ACCESS,FALSE,GetCurrentThreadId());

//	xASSERTE(sThreads[0].hThread != NULL);

	//arch_report("Thread #0 is main thread...\n");
}

u32_t sys_jiffies(void)	/* since power up. */
{
	return GetTickCount() - sJiffies;
}

/* The following functions are used only in Unix code, and
   can be omitted when porting the stack. */
/* returns the current time in microseconds. */
unsigned long sys_now(void)
{
	// Cmo podra representar 24 hs. en microseguntos en una variable de 32 bits?
	DBG(); return 0;
DBG();}

///////////////////////////////////////////////////////////////////////////////////////////
//
// SEMFOROS
//
///////////////////////////////////////////////////////////////////////////////////////////

/* Semaphore functions. */
#define MAX_SEM 16
int array_sem[MAX_SEM];


sys_sem_t sys_sem_new(u8_t count)
{   int n;
	for( n = 0 ; n < MAX_SEM && array_sem[n] != 0 ; n++ );

	//xASSERTE(n < MAX_SEM);
   array_sem[MAX_SEM]=0x1000+count;
	return  &array_sem[MAX_SEM]; // CreateSemaphore( NULL, count, 1, NULL );
}

void sys_sem_signal(sys_sem_t sem)
{	(* (int*)sem)++;
//	ReleaseSemaphore( sem, 1, NULL );
}
#define WAIT_TIMEOUT                     258L    // dderror
u32_t sys_arch_sem_wait(sys_sem_t sem, u32_t timeout)
{
	DWORD	wait = GetTickCount();
	DWORD	res = WaitForSingleObject1(sem,timeout);

	if( res == WAIT_TIMEOUT ) return SYS_ARCH_TIMEOUT;

	return GetTickCount() - wait;
}

void sys_sem_free(sys_sem_t sem)
{  (*(int*)sem)=0;
//	CloseHandle(sem);
}

///////////////////////////////////////////////////////////////////////////////////////////
//
// MAILBOXES
//
///////////////////////////////////////////////////////////////////////////////////////////
#define STATUS_WAIT_0                    ((DWORD   )0x00000000L)
#define WAIT_OBJECT_0       ((STATUS_WAIT_0 ) + 0 )


int WaitForSingleObject1( int * hd  ,int time )
 {// time/=10; // ivv
while(!(char)*hd) {
//	Sleep(1);
   if(!time--) return  WAIT_TIMEOUT;
	 SleepEx1(1,1);
// forth_exec( C_PAUSE );
 }
	 (*hd)--;
 return WAIT_OBJECT_0;
}


int WaitForSingleObject2( char hd  ,int time )
 {
while(! array_sem[hd]) {
//	Sleep(1);
   if(!time--) return  WAIT_TIMEOUT;
	 SleepEx1(1,1);
// forth_exec( C_PAUSE );
 }
	 (array_sem[hd])--;
 return WAIT_OBJECT_0;
}

sys_mbox_t sys_mbox_new(void)
{
	int		n;

	EnterCriticalSection(&sSync);

	for( n = 0 ; n < MAX_MAILBOXES && sMailboxes[n].hasdata != 0 ; n++ );

	// xASSERTE(n < MAX_MAILBOXES);

	sMailboxes[n].hasdata = 0x1000 ; // CreateSemaphore( NULL, 0, 1, NULL );
	sMailboxes[n].nodata = 0x1001 ; // CreateSemaphore( NULL, 1, 1, NULL );

//	xASSERTE( sMailboxes[n].hasdata != NULL );
//	xASSERTE( sMailboxes[n].nodata != NULL );

	sMailboxes[n].value = NULL;

	LeaveCriticalSection(&sSync);

	return n;
}
#define INFINITE            0xFFFFFFFF  // Infinite timeout
void sys_mbox_post(sys_mbox_t mbox, void *msg)
{
	DWORD	res;

	//xASSERTE( mbox >=0 && mbox < MAX_MAILBOXES );
	
	res = WaitForSingleObject1( &(sMailboxes[mbox].nodata), INFINITE );

//	xASSERTE( res == WAIT_OBJECT_0 );

	sMailboxes[mbox].value = msg;

// 1111	ReleaseSemaphore( sMailboxes[mbox].hasdata, 1, NULL );
  sMailboxes[mbox].hasdata=0x1001;
}

u32_t sys_arch_mbox_fetch(sys_mbox_t mbox, void **msg, u32_t timeout)
{
	DWORD	res;
	DWORD	wait = GetTickCount();

//	xASSERTE( mbox >=0 && mbox < MAX_MAILBOXES );
// 1111
	
	res = WaitForSingleObject1( &(sMailboxes[mbox].hasdata), timeout );

	if( res == WAIT_TIMEOUT ) return SYS_ARCH_TIMEOUT;

	*msg = sMailboxes[mbox].value;

//	ReleaseSemaphore( sMailboxes[mbox].nodata, 1, NULL );
  sMailboxes[mbox].nodata=0x1001;

	return GetTickCount() - wait;
}

void sys_mbox_free(sys_mbox_t mbox)
{
//	xASSERTE( mbox >=0 && mbox < MAX_MAILBOXES );

//	CloseHandle(sMailboxes[mbox].hasdata);
//	CloseHandle(sMailboxes[mbox].nodata);

	memset( &sMailboxes[mbox], 0, sizeof(sMailboxes[mbox]) );
DBG();}

///////////////////////////////////////////////////////////////////////////////////////////
//
// THREADS
//
///////////////////////////////////////////////////////////////////////////////////////////

sys_thread_t sys_thread_new(void (* thread)(void *arg), void *arg, int prio)
{
	// Ignoramos el argumento "prio"

	int		n;

	EnterCriticalSection(&sSync);

	for( n = 0 ; n < MAX_THREADS && sThreads[n].hThread != NULL ; n++ );

	//xASSERTE(n < MAX_THREADS);

	sThreads[n].hThread = (HANDLE) 0x5555; // CreateThread( NULL, 0, (LPTHREAD_START_ROUTINE) thread, NULL, CREATE_SUSPENDED, &sThreads[n].ThreadID );
	sThreads[n].ThreadID = task_cr(
                                       thread );
	memset( &sThreads[n].timeouts, 0, sizeof(sThreads[n].timeouts) );

	LeaveCriticalSection(&sSync);

	//xASSERTE( sThreads[n].hThread != NULL );

	//arch_report("Creating thread #%d, address 0x%08x...\n", n, thread);

//	ResumeThread(sThreads[n].hThread);

	return n;
}

struct sys_timeouts *sys_arch_timeouts(void)
{
	DWORD			id =  GetCurrentThreadId();
	int				n;

	for( n = 0 ; n < MAX_THREADS && id != sThreads[n].ThreadID ; n++ );

	//xASSERTE(n < MAX_THREADS);

	return &sThreads[n].timeouts;
}

///////////////////////////////////////////////////////////////////////////////////////////
//
// SERIAL PORT I/O
//
///////////////////////////////////////////////////////////////////////////////////////////

sio_fd_t sio_open(u8_t id)
{
	// Ignoramos el parmetro ID
	const	char*	init_strings[] =
	{
		"AT+CGDCONT=1,\"IP\",\"internet.mts.ru\",\"0.0.0.0\",0,0\r",
		"ATD*99#\r",
//		"CLIENT",
//		"CLIENT",
		//"CLIENT",
		 NULL ,
		"CLIENT",
		"AT$HOSTIF=3\r",
		"ATD*99#\r",
		NULL
	};

	HANDLE			h;
	//DCB				config;
	//COMMTIMEOUTS	touts;
	int				n;

	for( n = 0 ; init_strings[n] != NULL ; n++ )
	{
		sio_write( h, (char*) init_strings[n], strlen(init_strings[n]) );
//ivv		Sleep(500);
	}

	return h;
}

/* ivv
void sio_send(u8_t chr, sio_fd_t fid)
{
  DWORD	written;

	sio_dump("Written", &chr, written );
DBG();}
u8_t sio_recv(sio_fd_t fid)
{
	u8_t		buf;
	DWORD		bytesread;

	sio_dump("Read", &buf, bytesread=0 );

	DBG(); return buf;
DBG();}
*/

u8_t NoCarStr[]="NO CARRIER";
u8_t * NoCarCur;
int NoCarFlg;


u8_t LoginOKStr[]="Login OK";
u8_t * LoginOKCur;

u32_t sio_read(sio_fd_t fid, u8_t *buf, u32_t size)
{
 	DWORD		bytesread;
	u8_t * lbuf=buf;
	u32_t lsize = size;
        NoCarCur=NoCarStr;
        LoginOKCur=LoginOKStr;
   int zz= GetTickCount()+ 99;
    while( !ComCnt1() ) forth_exec( C_PAUSE );
   bytesread = 0;
   do
   { if( ComCnt1())
   { u8_t cc;
        cc=GetPort1();
       *lbuf++=cc; lsize--;

        if(*NoCarCur==cc) NoCarCur++;
        else NoCarCur=NoCarStr;

        if(NoCarCur==(&NoCarStr[8])) NoCarFlg=1;

/*
        if(*LoginOKCur==cc) LoginOKCur++;
        else LoginOKCur=LoginOKStr;

        if(LoginOKCur==(&LoginOKStr[8])) 
	{ gprintf0("sio_read: Login OK");
	  lsize-=8;
	    lbuf-=8;
	 }
*/

      zz= GetTickCount()+ 99;
   }
     else forth_exec( C_PAUSE );
   }while( lsize && ( GetTickCount()<zz ) );

    sio_dump("Read", buf, bytesread= (int)lbuf-(int)buf );

	return bytesread;
}

u32_t sio_write(sio_fd_t fid, u8_t *buf, u32_t size)
{
	u32_t written;
        u8_t *buffer=buf;

        for (; size != 0; --size)    usart1_send(*buffer++);

	sio_dump("Written", buf, written = (u32_t)buffer-(u32_t) buf );
	return written;
}

void sio_read_abort(sio_fd_t fid)
{
	// Se utiliza nicamente para terminar el enlace.
	// Podemos no implementarla, ya que la lectura fallar en CloseHandle()
}

///////////////////////////////////////////////////////////////////////////////////////////
//
// TRACE
//
///////////////////////////////////////////////////////////////////////////////////////////

void ppp_trace(int level, const char *format,...)
{
	g_write (NULL,(u8_t*)format, 60 );

}

/*
void ppp_trace(int level, const char *format,...)
{
#ifdef	TRACE_TO_STDOUT
	va_list	list;
        //gprintf
	va_start(list, format);
	EnterCriticalSection(&sOutSync);
	vprintf( format, list );
#ifdef TRACE_TO_FILE
	vfprintf( sDebug, format, list );
	fflush(sDebug);
#endif
	LeaveCriticalSection(&sOutSync);
	va_end(list);
#else
	char	buffer[4096];
	va_list	list;

	va_start(list, format);
	vsprintf( buffer, format, list );
#ifdef TRACE_TO_FILE
	vfprintf( sDebug, format, list );
	fflush(sDebug);
#endif
	va_end(list);

	_RPT0(_CRT_WARN,buffer);
#endif
}

*/
void arch_report( const char*format, ...)
{
#ifdef	TRACE_TO_STDOUT
	va_list	list;

	va_start(list, format);
	EnterCriticalSection(&sOutSync);
	vprintf( format, list );
#ifdef TRACE_TO_FILE
	vfprintf( sDebug, format, list );
	fflush(sDebug);
#endif
	LeaveCriticalSection(&sOutSync);
	va_end(list);
#else
	char	buffer[4096];
	va_list	list;

	va_start(list, format);
	vsprintf( buffer, format, list );
#ifdef TRACE_TO_FILE
	vfprintf( sDebug, format, list );
	fflush(sDebug);
#endif
	va_end(list);

	_RPT0(_CRT_WARN,buffer);
#endif
}



void sio_dump(const char* message,const u8_t* buf, u32_t size)
{
#ifdef	TRACE_TO_STDOUT
	int		n, m;

	EnterCriticalSection(&sOutSync);
//sprintf( pcStatusString, ( portCHAR * ) "%s\t\t%c\t%u\t%u\t%u\r\n", pxNextTCB->pcTaskName, cStatus, ( unsigned int ) pxNextTCB->uxPriority, usStackRemaining, ( unsigned int ) pxNextTCB->uxTCBNumber );

	gprintf2("%s %d bytes:\n",message,size);

	for(n=0;n<size;n+=16)
	{
		for(m=0;m<16;m++)
		{
			if( n+m < size )
			{
//                          sprintf(bofstdout,"%02x ", 0xff & (int) buf[n+m] );
//                          g_write (NULL,bofstdout, 60 );
                             CEMIT( ((buf[n+m] >>4))  <= 9 ? ((buf[n+m] >>4))+'0' : ((buf[n+m] >>4))-10+'A' );
                             CEMIT( (buf[n+m]&0xF)  <= 9 ? (buf[n+m]&0xF)+'0' : (buf[n+m]&0xF)-10+'A' );
                             CEMIT(' ');
                        }

			else
				gprintf0("   ");
		}
		gprintf0("    ");
		for(m=0;m<16;m++)
		{
			if( n+m >= size ) break;
			{ sprintf(bofstdout,"%c", (buf[n+m] >= ' ' && buf[n+m] < 127) ? buf[n+m] : '.' );
                          g_write (NULL,bofstdout, 60 );
                        }
		}
		gprintf0("\n");
	}
#ifdef TRACE_TO_FILE
        !!fprintf(sDebug,"%s %d bytes:\n",message,size);
	for(n=0;n<size;n+=16)
	{
		for(m=0;m<16;m++)
		{
			if( n+m < size )
				!!fprintf(sDebug,"%02x ", 0xff & (int) buf[n+m] );
			else
				!!fprintf(sDebug,"   ");
		}
		fprintf(sDebug,"    ");
		for(m=0;m<16;m++)
		{
			if( n+m >= size ) break;
			!!fprintf(sDebug,"%c", (buf[n+m] >= ' ' && buf[n+m] < 127) ? buf[n+m] : '.' );
		}
		!!fprintf(sDebug,"\n");
	}
	!!fflush(sDebug);
#endif
	LeaveCriticalSection(&sOutSync);
#endif
}
