//#include <targets/AT91SAM7.h>
#include "Project.h"
#include "adc.h"

void ADC_Init(unsigned char channels, unsigned int prescaler)
{
  AT91C_BASE_SYS->PMC_PCER = 1<<4; // Enable ADC clock.
  AT91C_BASE_ADC->ADC_CHER = channels; //enable channels
  AT91C_BASE_ADC->ADC_MR = prescaler << 8;
}

void ADC_StartConversion(void)
{
  AT91C_BASE_ADC->ADC_CR = 0x02; //start conversion
}

unsigned char ADC_DataReady(unsigned char channel)
{
  return (AT91C_BASE_ADC->ADC_SR & (1 << channel));
}

int ADC_ReadChannel(unsigned char channel)
{
  switch (channel)
  {
    case 0: return AT91C_BASE_ADC->ADC_CDR0;
    case 1: return AT91C_BASE_ADC->ADC_CDR1;
    case 2: return AT91C_BASE_ADC->ADC_CDR2;
    case 3: return AT91C_BASE_ADC->ADC_CDR3;
    case 4: return AT91C_BASE_ADC->ADC_CDR4;
    case 5: return AT91C_BASE_ADC->ADC_CDR5;
    case 6: return AT91C_BASE_ADC->ADC_CDR6;
    case 7: return AT91C_BASE_ADC->ADC_CDR7;
    default:return 0;
  }
  return 0;
}
