//#include "BoardAdd.h"
#include "EFC.h"
#include "Project.h"
#include "lib_at91sam7s256.h"
#include "C:\Program Files\IAR Systems\Embedded Workbench 4.0 Evaluation\ARM\inc\intrinsics.h" 
#define DWDT_CHOP CountWDT=0;
extern int CountWDT;

//#include "int.c"
__ramfunc void EFC_Init(void)
{
while (!(AT91C_BASE_MC->MC_FSR & AT91C_MC_FRDY)) ;
AT91C_BASE_MC->MC_FMR = ((AT91C_MC_FMCN)&(100 <<16)) | AT91C_MC_FWS_1FWS ;
while (!(AT91C_BASE_MC->MC_FSR & AT91C_MC_FRDY)) ;
}


// adr   0x00100000
// pbuf ..  EFC_PAGE_SIZE
__ramfunc u32 EFC_WritePage(u32 adr, u32 *pbuf)
{
unsigned int *pflash;
unsigned int page;
unsigned int region;
unsigned int i;

pflash = (unsigned int *)adr;
page = (adr & 0x3FFFF)/EFC_PAGE_SIZE;
region = (page/EFC_PagesInTheLockRegion);
  __disable_interrupt(); 

EFC_Init();

if (AT91C_BASE_MC->MC_FSR & (region << 16)) {
// lock set, clear it
AT91C_BASE_MC->MC_FMR = ((AT91C_MC_FMCN)&(50 <<16)) | AT91C_MC_FWS_2FWS ;
AT91C_BASE_MC->MC_FCR = (0x5A << 24) | (region << 8 ) |AT91C_MC_FCMD_UNLOCK;
}
while (!(AT91C_BASE_MC->MC_FSR & AT91C_MC_FRDY)) ;

for (i = 0; i < EFC_PAGE_SIZE_UINT; i++)
*(pflash + i ) = *(pbuf + i);

AT91C_BASE_MC->MC_FCR = (0x5A << 24) | (page << 8 ) |AT91C_MC_FCMD_START_PROG;
while (!(AT91C_BASE_MC->MC_FSR & AT91C_MC_FRDY)) ;
  __enable_interrupt(); 

return 1;
}


u32 RAMSectorData[EFC_PAGE_SIZE/4];
int page,page_prev;

#define DWDT_CHOP CountWDT=0;

void FlashSave()
{ DWDT_CHOP;
  EFC_WritePage(page_prev*EFC_PAGE_SIZE, RAMSectorData);
}

u8 * FlashWriteAddr(unsigned long  addr)
{ unsigned int NbByte;

  // get page
  page  = addr / EFC_PAGE_SIZE;

  //* Check if page must write
  if (page != page_prev)
  {  FlashSave();
 	// Copy Rom page to RAM page
        for (NbByte = 0; NbByte < (EFC_PAGE_SIZE/4); NbByte++)
        {
           RAMSectorData[NbByte] = ((u32 *) (page*EFC_PAGE_SIZE)) [NbByte];
        }
        //* set works page
        page_prev = page ;
   }
   //* Write data
  return  &((u8*)RAMSectorData)[ addr & (EFC_PAGE_SIZE-1)];
}

void FlashInit()
{ unsigned int NbByte;
 page=page_prev=0xC000/EFC_PAGE_SIZE;
          for (NbByte = 0; NbByte < EFC_PAGE_SIZE/4; NbByte++)
        {
           RAMSectorData[NbByte] = ((u32*) (page*EFC_PAGE_SIZE)) [NbByte];
        }

}
