;----------------------------------------------------------------------------
; extern void AT91F_enable_interrupt(void);
; Enable Core interrupt
;----------------------------------------------------------------------------*/
MODE_BITS	DEFINE	0x1F		; Bit mask for mode bits in CPSR
USR_MODE	DEFINE	0x10		; User mode
FIQ_MODE	DEFINE	0x11		; Fast Interrupt Request mode
IRQ_MODE	DEFINE	0x12		; Interrupt Request mode
SVC_MODE	DEFINE	0x13		; Supervisor mode
ABT_MODE	DEFINE	0x17		; Abort mode
UND_MODE	DEFINE	0x1B		; Undefined Instruction mode
SYS_MODE	DEFINE	0x1F		; System mode
	

  PROGRAM	XXXXX

		RSEG	ICODE:CODE:ROOT(2)
		CODE32	; Always ARM mode after reset	
__program_start

  PUBLIC AT91F_Enable_Interrupt
AT91F_Enable_Interrupt:

  mrs r0,CPSR
  bic r0,r0,#(IRQ_MODE | FIQ_MODE)
  msr CPSR_c,r0
  bx lr


;/*----------------------------------------------------------------------------
;/* extern void AT91F_disable_interrupt(void);
;/* Disable Core interrupt
;/*----------------------------------------------------------------------------*/
  PUBLIC  AT91F_Disable_Interrupt

AT91F_Disable_Interrupt:

  mrs r0,CPSR
  orr r0,r0,#(IRQ_MODE | FIQ_MODE)
  msr CPSR_c,r0
  mrs r0,CPSR
  ands r0,r0,#(IRQ_MODE | FIQ_MODE)
  beq AT91F_Disable_Interrupt
  bx lr
	ENDMOD

	END

