// ----------------------------------------------------------------------------
//         ATMEL Microcontroller Software Support  -  ROUSSET  -
// ----------------------------------------------------------------------------
// DISCLAIMER:  THIS SOFTWARE IS PROVIDED BY ATMEL "AS IS" AND ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT ARE
// DISCLAIMED. IN NO EVENT SHALL ATMEL BE LIABLE FOR ANY DIRECT, INDIRECT,
// INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
// LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
// OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
// LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
// NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
// EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
// ----------------------------------------------------------------------------
//  File Name           : main.c
//  Object              : main application written in C
//  1.0 24/Jun/04 JPP   : Creation
//  1.1 21/Feb/05 JPP   : Update AT91C_RSTC_URSTEN
//  1.2 29/Aug/05 JPP   : Update AIC definion
//  1.3 29/Jun/06 JPP   : Clean for genaration
//*----------------------------------------------------------------------------

#include "aa4th.h"
// Include Standard LIB  files
#include "Project.h"
#include "EFC.h"
#include "intrinsics.h"
//#include "project.h"
#include "adc\adc.h"
#define  CHANNEL 5

int cl_num=CHANNEL;

//*   Waiting time between LED1 and LED2
#define     WAIT_TIME       AT91B_MCK

#define PIO_INTERRUPT_LEVEL	6
#define IRQ0_INTERRUPT_LEVEL	2
#define SOFT_INTERRUPT_LEVEL	5
#define FIQ_INTERRUPT_LEVEL	0
#define DWDT_CHOP CountWDT=0
void WDT_CHOP();
//* Global variable
int count_timer0_interrupt;
int count_timer1_interrupt;

// Use the Library Handler defined in file periph/pio/pio_irq/irq_pio.s

extern void FlashWriteByte(unsigned long addr, int byte);

extern void FIQ_init_handler(void);

extern void at91_IRQ0_handler(void);
// External Function Prototype
extern void timer_init (void );
extern void Usart_init (void);

void test()
{
   AT91C_BASE_DBGU->DBGU_PTSR = AT91C_US_RSTRX | AT91C_US_RSTTX;
   AT91C_BASE_SYS->PIOA_PER = AT91C_US_RSTRX | AT91C_US_RSTTX;
}

//*----------------------------------------------------------------------------
//* Function Name       : aic_software_interrupt
//* Object              : Software interrupt function
//* Input Parameters    : none
//* Output Parameters   : none
//* Functions called    : at91_pio_write
//*----------------------------------------------------------------------------
void aic_software_interrupt(void)
{
    //* Read the output state
    if ( (AT91F_PIO_GetInput(AT91D_BASE_PIO_LED) & AT91B_LED2 ) == AT91B_LED2 )
    {
        AT91F_PIO_ClearOutput( AT91D_BASE_PIO_LED, AT91B_LED2 );
    }
    else
    {
        AT91F_PIO_SetOutput( AT91D_BASE_PIO_LED, AT91B_LED2 );
    }
}

//*----------------------------------------------------------------------------
//* Function Name       : pio_c_irq_handler
//* Object              : Irq Handler called by the irq_pio.s
//* Input Parameters    : none
//* Output Parameters   : none
//* Functions called    : at91_pio_read, at91_pio_write
//*----------------------------------------------------------------------------
void pio_c_irq_handler ( void )
{
int dummy;
    //* Read the output state
    if ( (AT91F_PIO_GetInput(AT91D_BASE_PIO_LED) & AT91B_LED2 ) == AT91B_LED2 )
    {
       AT91F_PIO_ClearOutput( AT91D_BASE_PIO_LED, AT91B_LED2);
    }
    else
    {
          AT91F_PIO_SetOutput( AT91D_BASE_PIO_LED, AT91B_LED2);
    }
    //* enable the next PIO IRQ
    dummy =AT91D_BASE_PIO_SW->PIO_ISR;
    //* suppress the compilation warning
    dummy =dummy;
    //* while SW3 is push wait
    while ( (AT91F_PIO_GetInput(AT91D_BASE_PIO_SW) & AT91B_SW3 ) != AT91B_SW3 );
}

//*----------------------------------------------------------------------------
//* Function Name       : delay
//* Object              : Wait
//* Input Parameters    : none
//* Output Parameters   : none
//* Functions called    : none
//*----------------------------------------------------------------------------
void delay ( void )
{
//* Set in Volatile for Optimisation
    volatile unsigned int    i ;
//* loop delay
    for ( i = 0 ;(i < WAIT_TIME/100 );i++ ) ;
}


/*-----------------------------------------------------------------------------
 * Function Name       : configure_dbgu
 * Object              : Configure DBGU
 *-----------------------------------------------------------------------------*/
static void configure_dbgu (void)
{
    /* Reset and disable receiver */
    AT91C_BASE_DBGU->DBGU_CR = AT91C_US_RSTRX | AT91C_US_RSTTX;

    /* Disable interrupts */
    AT91C_BASE_DBGU->DBGU_IDR = 0xFFFFFFFF;

    /* Configure PIOs for DBGU */
    AT91C_BASE_PIOA->PIO_ASR = AT91C_PA9_DRXD | AT91C_PA10_DTXD;
    AT91C_BASE_PIOA->PIO_BSR = 0;
    AT91C_BASE_PIOA->PIO_PDR = AT91C_PA9_DRXD | AT91C_PA10_DTXD;

    /* === Configure serial link === */
    /* Define the baud rate divisor register [BRGR = MCK / (115200 * 16)] */
    AT91C_BASE_DBGU->DBGU_BRGR = 26;  // 115200 // 94793.1 KHz //(MCK / 16 / UPLINK_BAUDRATE) + 0.5;
//  AT91C_BASE_DBGU->DBGU_BRGR = 3;
//    AT91C_BASE_DBGU->DBGU_BRGR = 5;  // 115200 // 9600.00 KHz
//  AT91C_BASE_DBGU->DBGU_BRGR = 76;  // 38400 // 94793.1 KHz
    /* Define the USART mode */
    AT91C_BASE_DBGU->DBGU_MR = AT91C_US_CHMODE_NORMAL;

    /* Disable the RX and TX PDC transfer requests */
    AT91C_BASE_DBGU->DBGU_PTCR = AT91C_PDC_RXTDIS;
    AT91C_BASE_DBGU->DBGU_PTCR = AT91C_PDC_TXTDIS;

    /* Enable transmitter */
    AT91C_BASE_DBGU->DBGU_CR = AT91C_US_TXEN|AT91C_US_RXEN;
}


//*----------------------------------------------------------------------------
//* Function Name       : main
//* Object              : Main interrupt function
//*		level timer 0 => 1
//*	SW2	level Irq0    => 2
//*		level timer 1 => 4
//*	SW4	level PIOA    => 6
//*		level USART   => 7
//*		LEVEL FIQ     => MAX
//* Input Parameters    : none
//* Output Parameters   : TRUE
//*----------------------------------------------------------------------------

int USER_OUT_VAR;

void USER_OUT_ON()
{ USER_OUT_VAR=-1;
  AT91F_PIO_SetOutput( AT91D_BASE_PIO_LED, AT91C_PIO_PA2 );
}
void USER_OUT_OFF()
{ USER_OUT_VAR=0;
  AT91F_PIO_ClearOutput( AT91D_BASE_PIO_LED, AT91C_PIO_PA2 );
}

void USER_IN()
{  AT91F_PIO_ClearOutput( AT91D_BASE_PIO_LED, AT91C_PIO_PA2 );
}

void EXTPGPS_OFF()
{  AT91F_PIO_SetOutput( AT91D_BASE_PIO_LED, AT91C_PIO_PA19 );
}
void EXTPGPS_ON()
{  AT91F_PIO_ClearOutput( AT91D_BASE_PIO_LED, AT91C_PIO_PA19 );
}


void EXTPGSM_OFF()
{  AT91F_PIO_SetOutput( AT91D_BASE_PIO_LED, AT91C_PIO_PA20 );
}
void EXTPGSM_ON()
{  AT91F_PIO_ClearOutput( AT91D_BASE_PIO_LED, AT91C_PIO_PA20 );
}

void POWER_GSM_ON()
{  AT91F_PIO_SetOutput( AT91D_BASE_PIO_LED, AT91C_PIO_PA17 );
}
void POWER_GSM_OFF()
{  AT91F_PIO_ClearOutput( AT91D_BASE_PIO_LED, AT91C_PIO_PA17 );
}


void CHARG_ON()
{  AT91F_PIO_SetOutput( AT91D_BASE_PIO_LED, AT91C_PIO_PA16 );
}
void CHARG_OFF()
{  AT91F_PIO_ClearOutput( AT91D_BASE_PIO_LED, AT91C_PIO_PA16 );
}

void POWER_ACC_ON()
{  AT91F_PIO_SetOutput( AT91D_BASE_PIO_LED, AT91C_PIO_PA4 );
}
void POWER_ACC_OFF()
{  AT91F_PIO_ClearOutput( AT91D_BASE_PIO_LED, AT91C_PIO_PA4 );
}


void tst()
{ for(;;)
 { char cc=0x55;
         while (!(AT91C_BASE_DBGU->DBGU_CSR & AT91C_US_RXRDY));
       cc= AT91C_BASE_DBGU->DBGU_RHR+1;
         while (!(AT91C_BASE_DBGU->DBGU_CSR & AT91C_US_TXRDY));
        AT91C_BASE_DBGU->DBGU_THR = cc;

 }

}

void cput(char cc)
{
   while(!(AT91F_US_TxReady(AT91C_BASE_US0)))
    {}
    AT91F_US_PutChar(AT91C_BASE_US0, cc);

    while(!(AT91F_US_TxReady(AT91C_BASE_US1)))
    {}
    AT91F_US_PutChar(AT91C_BASE_US1, cc);
}

void CPEMIT(char cc)
{
   while(!(AT91F_US_TxReady(AT91C_BASE_US0)))
    {}
    AT91F_US_PutChar(AT91C_BASE_US0, cc);
}

void CGEMIT(char cc)
{
    while(!(AT91F_US_TxReady(AT91C_BASE_US1)))
    {}
    AT91F_US_PutChar(AT91C_BASE_US1, cc);
}

// Hardware initialization function.
static void Initialize(void)
{
    // Set Flash Wait sate: 0 wait states.
    AT91C_BASE_MC->MC_FMR = ((AT91C_MC_FMCN)&(22 <<16)) | AT91C_MC_FWS_0FWS;

    // Disable watchdog.
//    AT91C_BASE_WDTC->WDTC_WDMR= AT91C_WDTC_WDDIS;

    // Start up the main oscillator.
    AT91PS_PMC pPMC = AT91C_BASE_PMC;
    pPMC->PMC_MOR = (( AT91C_CKGR_OSCOUNT & (6U <<8)) | AT91C_CKGR_MOSCEN );
    while(!(pPMC->PMC_SR & AT91C_PMC_MOSCS));

    // Select master clock (MCK): Main oscillator.
    pPMC->PMC_MCKR = AT91C_PMC_CSS_MAIN_CLK;
    while(!(pPMC->PMC_SR & AT91C_PMC_MCKRDY));
    pPMC->PMC_MCKR = AT91C_PMC_CSS_MAIN_CLK | AT91C_PMC_PRES_CLK;
    while(!(pPMC->PMC_SR & AT91C_PMC_MCKRDY));

    // Enable user reset. This aids in debugging.
//    AT91C_BASE_RSTC->RSTC_RMR = 0xa5000400U | AT91C_RSTC_URSTEN;

    // Set up the default interrupt handlers. 0 = FIQ, 1 = SYS.
//    int i;
//    for(i=0; i<31; i++)
//    {  AT91C_BASE_AIC->AIC_SVR[i] = (unsigned)&DefaultInterruptHandler;  }
//    AT91C_BASE_AIC->AIC_SPU = (unsigned)&SpuriousInterruptHandler;

    // Set up the IOs.
//    volatile AT91PS_PIO pPIO = AT91C_BASE_PIOA;
//    pPIO->PIO_PER = LED_A | LED_B;   // Allow PIO to control LEDs.
//    pPIO->PIO_OER = LED_A | LED_B;   // Enable outputs for LED pins.
//    pPIO->PIO_SODR = LED_A | LED_B;  // Set outputs HIGH to turn LEDs off.

     AT91C_BASE_PMC->PMC_PLLR = AT91C_CKGR_USBDIV_1           |
    						   (16 << 8)                     |
                               (AT91C_CKGR_MUL & (72 << 16)) |
                               (AT91C_CKGR_DIV & 14);

    // Wait for PLL stabilization
    while( !(AT91C_BASE_PMC->PMC_SR & AT91C_PMC_LOCK) );
    // Wait until the master clock is established for the case we already
    // turn on the PLL
    while( !(AT91C_BASE_PMC->PMC_SR & AT91C_PMC_MCKRDY) );

}
extern int volatile CountWDT;

#define period 0xf

#define AT91B_LED_MASK  ( \
 AT91C_PIO_PA0  /* sleep acc */ \
|AT91C_PIO_PA2  /* ext wire 1 */ \
|AT91C_PIO_PA17 /* pwkey */ \
|AT91C_PIO_PA19 /* gps power */ \
|AT91C_PIO_PA24 /* rts */ \
|AT91C_PIO_PA27 /* dtr */ \
)

void CEMIT(char cc)
{
  while (!(AT91C_BASE_DBGU->DBGU_CSR & AT91C_US_TXRDY));
  AT91C_BASE_DBGU->DBGU_THR = 0xA;
  while (!(AT91C_BASE_DBGU->DBGU_CSR & AT91C_US_TXRDY));
  AT91C_BASE_DBGU->DBGU_THR = cc;
}

extern unsigned volatile timecou;
unsigned xtimecou;
unsigned ttt=0;

unsigned GetTickCount()
{
    if (ttt < timecou*30)
      ttt=timecou*30;
    else if (ttt < (timecou+1)*30)
          ttt++;

  return ttt;
} 

int forth_exec_cnt=0;
int forth_exec( void (  cfa() ) )
{ int acc=0;
  forth_exec_cnt++;
  WDT_CHOP();
//  if(*(int*)(0x20b36c)&3)  { DBG(); }
//  else
    acc=Aforth_exec( cfa );
    DBG();
  return acc;
}

void clearall()
{
   AT91F_PIO_ClearOutput (  AT91C_BASE_PIOA,
 		 ~((unsigned int)AT91C_PA9_DRXD | (unsigned int)AT91C_PA10_DTXD)    );
}
void setpinall()
{
   AT91F_PIO_SetOutput (  AT91C_BASE_PIOA,
 		 ~((unsigned int)0)     );
 	

}

void disall()
{
    	AT91F_PIO_CfgOutput(  AT91C_BASE_PIOA,
 		 ~((unsigned int)AT91C_PA9_DRXD | (unsigned int)AT91C_PA10_DTXD)    );


}

void lowleveldbgu()
{
   AT91PS_AIC     pAic;

        pAic = AT91C_BASE_AIC;

	AT91C_BASE_RSTC->RSTC_RMR = AT91C_RSTC_URSTEN | (0x4<<8) | (unsigned int)(0xA5<<24);

    	AT91F_PMC_EnablePeriphClock ( AT91C_BASE_PMC, 1 << AT91C_ID_PIOA ) ;

}

extern volatile aseconds;
void cinit()
{
   	//* then, we configure the PIO Lines corresponding to LED1 to LED8
   	//* to be outputs. No need to set these pins to be driven by the PIO because it is GPIO pins only.
    	AT91F_PIO_CfgOutput( AT91D_BASE_PIO_LED, AT91B_LED_MASK ) ;
//        for(;;);
   	//* Clear the LED's. On the EB55 we must apply a "1" to turn off LEDs
   	AT91F_PIO_SetOutput( AT91D_BASE_PIO_LED, AT91B_LED_MASK&(~AT91C_PIO_PA2) ) ;
    USER_OUT_OFF();

    	AT91F_PIO_CfgInput( AT91D_BASE_PIO_LED, AT91B_IN_MASK

                           ) ;
        AT91D_BASE_PIO_LED->PIO_PPUDR = AT91B_IN_MASK; // !!!!!
        

//        timer_init();
    /* ==== DBGU configuration ==== */
//  configure_dbgu();

    //* Init Usart
        Usart_init();
        Usart_init1();
}


/*
+Voltage regulator is in Low-power mode,
+MCK is working at 500 Hz,
+All peripheral clocks are de-activated,
+USB transceiver disabled (*),
-Analog-to-Digital Converter de-activated,
? Brownout Detector is de-activated, -- RSTC_RMR
- flash is in standby mode,
- ARM Core is in Idle mode,

DDM and DDP pins connected to ground (*).
VDDIN, VDDIO and VDDFLASH @ 3.3V,
VDDCORE, VDDPLL and VDDOUT @ 1.8V.

*/
void Ultra_Low_Power_Mode (void)
{

unsigned int tmp;
int *usb_reg = (int *)0xfffb0074;

AT91PS_PMC pPMC = AT91C_BASE_PMC;
AT91PS_VREG pVREG = AT91C_BASE_VREG;

// Disable the USB Transceiver (*)
pPMC->PMC_PCER=1<<11;
*usb_reg = 0x100;
pPMC->PMC_PCDR=1<<11;
// Switch the Master Clock (MCK) to Slow Clock
tmp = pPMC->PMC_MCKR;
tmp &= ~AT91C_PMC_CSS;
tmp |= AT91C_PMC_CSS_SLOW_CLK;
pPMC->PMC_MCKR =tmp ;
while(!(pPMC->PMC_SR & AT91C_PMC_MCKRDY));
// Disable all peripheral clocks
pPMC->PMC_PCDR = 0xFFFFFFFF;
// Disable the PLL
pPMC->PMC_PLLR = 0x0;
// Disable the Main Oscillator
pPMC->PMC_MOR = 0x0;
// Put the Voltage Regulator in Standby Mode
pVREG->VREG_MR = 0x1;
// Reduce the MCK Frequency Down to 500 Hz
tmp = pPMC->PMC_MCKR;
tmp &= ~AT91C_PMC_PRES;
tmp |= AT91C_PMC_PRES_CLK_64;
pPMC->PMC_MCKR = tmp ;
while(!(pPMC->PMC_SR & AT91C_PMC_MCKRDY));
/* At this stage, PCK and MCK are running from the slow clock oscillator at 500Hz */
/* Enter the processor in Idle Mode - Disable Processor Clock */
pPMC->PMC_SCDR = 0x1;
/* At this stage, MCK is running from the slow clock oscillator at 500Hz */
/* The PCK is disabled and waiting for an interrupt */
}

int WASALARM;
int PWSW;

__ramfunc void noalarm()
{

//   setpinall();  //1111111111!!!!!!!!
  __disable_interrupt();
unsigned int tmp;
int *usb_reg = (int *)0xfffb0074;

AT91PS_PMC pPMC = AT91C_BASE_PMC;
AT91PS_VREG pVREG = AT91C_BASE_VREG;

// Disable the USB Transceiver (*)
pPMC->PMC_PCER=1<<11;
*usb_reg = 0x100;
pPMC->PMC_PCDR=1<<11;
// Switch the Master Clock (MCK) to Slow Clock
tmp = pPMC->PMC_MCKR;
tmp &= ~AT91C_PMC_CSS;
tmp |= AT91C_PMC_CSS_SLOW_CLK;
pPMC->PMC_MCKR =tmp ;
while(!(pPMC->PMC_SR & AT91C_PMC_MCKRDY));
// Disable all peripheral clocks
pPMC->PMC_PCDR = 0xFFFFFFFF;
// Disable the PLL
pPMC->PMC_PLLR = 0x0;
// Disable the Main Oscillator
pPMC->PMC_MOR = 0x0;
// Put the Voltage Regulator in Standby Mode
pVREG->VREG_MR = 0x1;
// Reduce the MCK Frequency Down to 500 Hz
tmp = pPMC->PMC_MCKR;
tmp &= ~AT91C_PMC_PRES;
tmp |= AT91C_PMC_PRES_CLK_64;
pPMC->PMC_MCKR = tmp ;
while(!(pPMC->PMC_SR & AT91C_PMC_MCKRDY));
/* At this stage, PCK and MCK are running from the slow clock oscillator at 500Hz */
/* Enter the processor in Idle Mode - Disable Processor Clock */
// pPMC->PMC_SCDR = 0x1;
/* At this stage, MCK is running from the slow clock oscillator at 500Hz */
}

// http://support.atmel.no/bin/customer?custSessionKey=&customerLang=en&noCookies=true&action=viewKbEntry&id=200
__ramfunc void TmpUltraLowPowerMode (int loops )
{ int CPWSW;
  //     RS -     -  
  int AlSave= AT91C_PIO_PA30 ^ ( AT91F_PIO_GetInput(AT91D_BASE_PIO_LED) & AT91C_PIO_PA30) ;
  WASALARM=0;
  PWSW=0;
  CPWSW=AT91F_PIO_GetInput(AT91D_BASE_PIO_LED) & AT91C_PIO_PA1;
     AT91C_BASE_US1->US_CR = AT91C_US_RXDIS | AT91C_US_TXDIS;
     AT91C_BASE_US0->US_CR = AT91C_US_RXDIS | AT91C_US_TXDIS;
     AT91C_BASE_DBGU->DBGU_CR = AT91C_US_RXDIS | AT91C_US_TXDIS;\

       AT91F_PIO_CfgOutput(  AT91C_BASE_PIOA,	~(
         (unsigned int) AT91C_PIO_PA1  |
//           (unsigned int) AT91C_PIO_PA15 |
//           (unsigned int) AT91C_PIO_PA18 |
// 		(unsigned int) AT91C_PA21_RXD1 |
// 		(unsigned int) AT91C_PA22_TXD1 |
              (unsigned int) AT91C_PA24_RTS1
//           |	        (unsigned int) AT91C_PA25_CTS1

             )
          );
           AT91F_PIO_SetOutput (  AT91C_BASE_PIOA,~(
         (unsigned int) AT91C_PIO_PA1  |
//           (unsigned int) AT91C_PIO_PA15 |
//           (unsigned int) AT91C_PIO_PA18  |
// 		(unsigned int) AT91C_PA21_RXD1 |
// 		(unsigned int) AT91C_PA22_TXD1 |
 		(unsigned int) AT91C_PA24_RTS1
// 		|(unsigned int) AT91C_PA25_CTS1


             )
           );
//  AT91F_PIO_Disable(AT91C_BASE_PIOA,~(0)); //    2 
  AT91F_PMC_DisablePeriphClock ( AT91C_BASE_PMC, 0xFFFFFFFF );
  AT91F_ADC_CfgModeReg(AT91C_BASE_ADC, AT91C_ADC_SLEEP_MODE);
  AT91C_BASE_MC->MC_FMR = AT91C_MC_FWS;

  noalarm();
/* The PCK is disabled and waiting for an interrupt */
//do{   }
 while(loops--)
 { __asm(" b  .+4");
   if( (loops & 0x3f) == 0 ) 
   {  
     AT91F_LowLevelInit();
     lowleveldbgu();
    	AT91F_PIO_CfgInput( AT91D_BASE_PIO_LED, AT91B_IN_MASK);
        if ( ! ( AlSave | (AT91F_PIO_GetInput(AT91D_BASE_PIO_LED) & AT91C_PIO_PA30 )  )
           )
        { WASALARM=-1; goto alarm;
        }
	if ( CPWSW!=(AT91F_PIO_GetInput(AT91D_BASE_PIO_LED) & AT91C_PIO_PA1))
	{ PWSW=-1; goto alarm;
	}
        AlSave = AT91C_PIO_PA30 ^ ( AT91F_PIO_GetInput(AT91D_BASE_PIO_LED) & AT91C_PIO_PA30) ;
          noalarm();
   }  DWDT_CHOP;
 };
// Initialize();
 AT91F_LowLevelInit();
 lowleveldbgu();
alarm:
configure_dbgu();
timer_init();
 cinit();
 FlashInit();
 __enable_interrupt();
// __asm(" b  0");

}
__ramfunc
void PowerDown( int loops )
{

// Disable Interrupts
AT91F_AIC_DisableIt(AT91C_BASE_AIC, 0xFFFFFFFF );

//Analog-to-Digital Converter de-activated.
AT91F_ADC_CfgModeReg(AT91C_BASE_ADC, AT91C_ADC_SLEEP_MODE);

//USB transceiver disabled.
AT91F_UDP_DisableTransceiver(AT91C_BASE_UDP);
//ARM Core in idle mode.
AT91F_PMC_CfgSysClkDisableReg(AT91C_BASE_PMC, AT91C_PMC_UDP | AT91C_PMC_PCK | AT91C_PMC_PCK0 | AT91C_PMC_PCK1 | AT91C_PMC_PCK2);

// Pull-Up off
AT91F_PIO_CfgPullup(AT91C_BASE_PIOA,0xFFFFFFFF);
//AT91F_PIO_CfgPullup(AT91C_BASE_PIOA,0);
//Tri-state
//AT91F_PIO_CfgOpendrain(AT91C_BASE_PIOA,0xFFFFFFFF);
//AT91F_PIO_CfgOpendrain(AT91C_BASE_PIOA,0);
//   
//AT91F_PIO_CfgInput(AT91C_BASE_PIOA,0xFFFFFFFF);

//All peripheral clocks de-activated.
AT91F_PMC_DisablePeriphClock ( AT91C_BASE_PMC, 0xFFFFFFFF );

//MCK @ 500Hz.
AT91F_PMC_CfgMCKReg (AT91C_BASE_PMC,AT91C_PMC_CSS_SLOW_CLK | AT91C_PMC_PRES_CLK_4);
while(!(AT91F_PMC_GetStatus(AT91C_BASE_PMC) & AT91C_PMC_MCKRDY));

AT91F_CKGR_CfgPLLReg(AT91C_BASE_CKGR,0);

// Disable Main Oscillator
AT91F_CKGR_DisableMainOscillator(AT91C_BASE_CKGR);
while(!(AT91F_PMC_GetStatus(AT91C_BASE_PMC) & AT91C_PMC_MOSCS));

//Voltage regulator is in Low-power mode.
AT91F_VREG_Enable_LowPowerMode(AT91C_BASE_VREG);

//ARM Core in idle mode.
// PowerDownAbsolute();

 while(loops--);
// Initialize();
 AT91F_LowLevelInit();
 lowleveldbgu();
configure_dbgu();
timer_init();
 cinit();
// FlashInit();
 __enable_interrupt();
// __asm(" b  0");

}

void PWDOWN()
{ PowerDown(1200); }

void RESET ()
{
  __disable_interrupt();
unsigned int tmp;
int *usb_reg = (int *)0xfffb0074;

AT91PS_PMC pPMC = AT91C_BASE_PMC;
AT91PS_VREG pVREG = AT91C_BASE_VREG;

// Disable the USB Transceiver (*)
pPMC->PMC_PCER=1<<11;
*usb_reg = 0x100;
pPMC->PMC_PCDR=1<<11;
// Switch the Master Clock (MCK) to Slow Clock
tmp = pPMC->PMC_MCKR;
tmp &= ~AT91C_PMC_CSS;
tmp |= AT91C_PMC_CSS_SLOW_CLK;
pPMC->PMC_MCKR =tmp ;
while(!(pPMC->PMC_SR & AT91C_PMC_MCKRDY));
// Disable all peripheral clocks
pPMC->PMC_PCDR = 0xFFFFFFFF;
// Disable the PLL
pPMC->PMC_PLLR = 0x0;
// Disable the Main Oscillator
pPMC->PMC_MOR = 0x0;
// Put the Voltage Regulator in Standby Mode
pVREG->VREG_MR = 0x1;
// Reduce the MCK Frequency Down to 500 Hz
tmp = pPMC->PMC_MCKR;
tmp &= ~AT91C_PMC_PRES;
tmp |= AT91C_PMC_PRES_CLK_64;
pPMC->PMC_MCKR = tmp ;
while(!(pPMC->PMC_SR & AT91C_PMC_MCKRDY));
/* At this stage, PCK and MCK are running from the slow clock oscillator at 500Hz */
/* Enter the processor in Idle Mode - Disable Processor Clock */
// pPMC->PMC_SCDR = 0x1;
/* At this stage, MCK is running from the slow clock oscillator at 500Hz */
/* The PCK is disabled and waiting for an interrupt */
__asm(" b  0");
}

unsigned zzzz;

#define sp_size 0x80
#define dp_size 0x1244+sp_size
int sp_buff[dp_size];

void WDT_CHOP()
{	DWDT_CHOP;
}

void delay_SL(unsigned delay)
{        int ii;
  delay&=0xFFF; // !!!!!!!!
       DWDT_CHOP ;
      while(delay){
        ii=0x1fff;     while(ii--);     DWDT_CHOP;
        ii=0x1fff;     while(ii--);     DWDT_CHOP;
        ii=0x1fff;     while(ii--);     DWDT_CHOP;
        ii=0x1fff;     while(ii--);     DWDT_CHOP;
        ii=0x1fff;     while(ii--);     DWDT_CHOP;
        ii=0x1fff;     while(ii--);     DWDT_CHOP;
        ii=0x1fff;     while(ii--);     DWDT_CHOP;
        ii=0x1fff;     while(ii--);     DWDT_CHOP;
        delay--;
      }
       DWDT_CHOP ;

}

unsigned h_titude;
unsigned l_titude;
unsigned g_titude;

void titude_()
{ g_titude=
 (h_titude/100*60+
 h_titude%100)*100000L
   +l_titude; }

void untitude_()
{
  l_titude=g_titude%100000L;
   h_titude=
     (g_titude-l_titude)/100000L / 60 * 100 +
     (g_titude-l_titude)/100000L % 60;
}


void GSM_SW2()
{
POWER_GSM_ON(); // P1OUT|=BIT0;
 delay_SL(0x15);
POWER_GSM_OFF(); // P1OUT&=~BIT0;
 delay_SL(0x10);
POWER_GSM_ON(); // P1OUT|=BIT0;
}
void intdelay(int ptimecou)
{
 int volatile ltimecou=timecou;
  while((timecou-ltimecou)<ptimecou) DWDT_CHOP;
}
void GSM_SW()
{ USART_DIS1();
POWER_GSM_ON(); // P1OUT|=BIT0;
 intdelay(24*2);
POWER_GSM_OFF(); // P1OUT&=~BIT0;
 intdelay(24);
POWER_GSM_ON(); // P1OUT|=BIT0;
Usart_init1();
}


//18432 / 192 * 100 = 9600(MHz);
int CKGR_DIV=0x200;

void FreqSub()
{
AT91C_BASE_PMC->PMC_PLLR=((AT91C_CKGR_DIV & CKGR_DIV--) | (AT91C_CKGR_PLLCOUNT & (1<<8)) | (AT91C_CKGR_MUL & (72<<16)));



    // Wait for PLL stabilization
    while( !(AT91C_BASE_PMC->PMC_SR & AT91C_PMC_LOCK) );
    // Wait until the master clock is established for the case we already
    // turn on the PLL
    while( !(AT91C_BASE_PMC->PMC_SR & AT91C_PMC_MCKRDY) );
}

int SREGS[3];
int TSKCFA;

int DATA5=0;
int COUNT5=0;

int DATA6=0;
int COUNT6=0;

int DATA7=0;
int COUNT7=0;

short ttdddd;
void DOADC5()
{
    AT91C_BASE_ADC->ADC_CR = 0x01;
    ADC_Init(  (1<<5)  , 10);
 ADC_StartConversion(); //start the convertion
    while (!(ADC_DataReady(5)));
    { ttdddd=AT91C_BASE_ADC->ADC_CDR5;
    if(CountWDT>6) return ;
//    DWDT_CHOP;
    }

ADC_StartConversion(); //start the convertion
    while (!(ADC_DataReady(5)))
          if(CountWDT>6) return ;
    DATA5+=AT91C_BASE_ADC->ADC_CDR5;
    COUNT5++;
}

void DOADC6()
{
    AT91C_BASE_ADC->ADC_CR = 0x01;
  ADC_Init(  (1<<6)  , 10);
//  AT91C_BASE_ADC->ADC_CHER = (1<<6);
ADC_StartConversion(); //start the convertion
    while (!(ADC_DataReady(6)));
    { ttdddd=AT91C_BASE_ADC->ADC_CDR6;
          if(CountWDT>6) return ;
    }
ADC_StartConversion(); //start the convertion

    while (!(ADC_DataReady(6)))
                if(CountWDT>6) return ;
  DATA6+=AT91C_BASE_ADC->ADC_CDR6;
    COUNT6++;
}

void DOADC7()
{
    AT91C_BASE_ADC->ADC_CR = 0x01;
  ADC_Init(  (1<<7)  , 10);
//  AT91C_BASE_ADC->ADC_CHER = (1<<7);
ADC_StartConversion(); //start the convertion
    while (!(ADC_DataReady(7)));
    { ttdddd=AT91C_BASE_ADC->ADC_CDR7;
          if(CountWDT>6) return ;
    }
ADC_StartConversion(); //start the convertion

    while (!(ADC_DataReady(7)))
                if(CountWDT>6) return ;
  DATA7+=AT91C_BASE_ADC->ADC_CDR7;
    COUNT7++;
}

void ADCTODATA()
{
    ADC_StartConversion(); //start the convertion
    while (!(ADC_DataReady(5))); //wait till conversion ends
    while (!(ADC_DataReady(6))); //wait till conversion ends
    while (!(ADC_DataReady(7))); //wait till conversion ends
    DATA5= ADC_ReadChannel(5);
    DATA6= ADC_ReadChannel(6);
    DATA7= ADC_ReadChannel(7);
}

void wait(volatile unsigned int d)
{
  for (;d ;--d);
}

void UDPDIS();
void UDPREM();
void AACOM();
void AAFOR();

int main( void )
{
// ADC5();  wait(100000); ADC6();



lowleveldbgu();
configure_dbgu();

/*
   	AT91F_PIO_CfgInput( AT91D_BASE_PIO_LED, AT91C_PIO_PA1) ;
//      AT91D_BASE_PIO_LED->PIO_PPUDR = AT91C_PIO_PA30; // !!!!!
        
        
        for(;;)
        { char cc;
          int sec;
          if( AT91F_PIO_GetInput(AT91D_BASE_PIO_LED) & AT91C_PIO_PA1)
            cc='1';
          else 
            cc='0';
//         sec=aseconds;
//         while(sec==aseconds);
          for(int volatile ii=0;  ii<99999 ;ii++);
          
              while (!(AT91C_BASE_DBGU->DBGU_CSR & AT91C_US_TXRDY));
        AT91C_BASE_DBGU->DBGU_THR = cc;

        }

*/


 timer_init();

 cinit();  ///!!!!!!!!!!!!!!

 EXTPGPS_ON();
 CHARG_OFF();
 POWER_ACC_ON();
        zzzz=ComCnt0();

        FlashInit();

    FORTH_MAIN(&sp_buff[dp_size-2]);

 FlashSave();
 FlashWriteAddr(0xf000);
    USER_OUT_ON();
     USER_OUT_OFF();
  EXTPGPS_ON();
  EXTPGPS_OFF();
//  PA15_GPS_ON();  PA15_GPS_OFF();  GPS_MRST_ON();  GPS_MRST_OFF();
  POWER_GSM_ON();
  POWER_GSM_OFF();
 EXTPGSM_ON();
 EXTPGSM_OFF();
 CHARG_ON();
 CHARG_OFF();
 POWER_ACC_ON();
 POWER_ACC_OFF();
GSM_SW();
//GPS_INIT();
     tst();
     sp_buff[dp_size]=zzzz;
        cput(0xd);
 GetPort0();
 GetPort1();
ComCnt0();
ComCnt1();
 CPEMIT(0);
 CGEMIT(0);
 usart1_send(0);
 QGSM_INT_ON();
 WDT_CHOP();
 untitude_();
   titude_();
 TmpUltraLowPowerMode(0);
 ADCTODATA();
  DOADC5();
  DOADC6();
  DOADC7();
 pppmain();
 FreqSub();
 forthwdt();
 UDPDIS();
 UDPREM();
 AAFOR();
 AACOM();

 clearall();
 setpinall();
 disall();
PWDOWN();
        Usart_init();
        Usart_init1();

 // mins=CountWDT;
 for(;;)
 { char cc=0x55;
         while (!(AT91C_BASE_DBGU->DBGU_CSR & AT91C_US_RXRDY));
         cc= AT91C_BASE_DBGU->DBGU_RHR+1;
         while (!(AT91C_BASE_DBGU->DBGU_CSR & AT91C_US_TXRDY));
        AT91C_BASE_DBGU->DBGU_THR = cc;

 }

for(;;)
{    while(!(AT91F_US_TxReady(AT91C_BASE_US0)))
    {}
    AT91F_US_PutChar(AT91C_BASE_US0, 0x55);

    while(!(AT91F_US_TxReady(AT91C_BASE_US1)))
    {}
    AT91F_US_PutChar(AT91C_BASE_US1, 0x55 );
}
    //* generate software interrupt
//        AT91F_AIC_Trig (pAic,AT91C_ID_SYS) ;

for (;;)
    {
//        AT91F_PIO_ClearOutput( AT91D_BASE_PIO_LED, AT91B_LED1 );
        delay () ;
//        AT91F_PIO_SetOutput( AT91D_BASE_PIO_LED, AT91B_LED1 );
        delay () ;

 //       loop_count ++ ;
    //* Set LED by software interrupt
//        if (loop_count == 10)
        {
//             loop_count=0;
         //* Software interrupt
//             AT91F_AIC_Trig (pAic,AT91C_ID_SYS) ;
        }
    }

//* End

}

/*  AT91C_BASE_PMC->PMC_IDR=
 AT91C_PMC_MOSCS|         // (PMC) MOSC Status/Enable/Disable/Mask
 AT91C_PMC_LOCK|          // (PMC) PLL Status/Enable/Disable/Mask
 AT91C_PMC_MCKRDY|        // (PMC) MCK_RDY Status/Enable/Disable/Mask
 AT91C_PMC_PCK0RDY|       // (PMC) PCK0_RDY Status/Enable/Disable/Mask
 AT91C_PMC_PCK1RDY|       // (PMC) PCK1_RDY Status/Enable/Disable/Mask
 AT91C_PMC_PCK2RDY        // (PMC) PCK2_RDY Status/Enable/Disable/Mask
 ;

   AT91C_BASE_PMC->PMC_SCDR=
     AT91C_PMC_PCK|AT91C_PMC_UDP|AT91C_PMC_PCK0| AT91C_PMC_PCK1|AT91C_PMC_PCK2;
   AT91C_BASE_PMC->PMC_PCDR=0xFFFFFFFF;
// for(;;);
 if(0)
 {

    TmpUltraLowPowerMode(-1);
 for(;;);
 }
*/