.( Corporate multitask )

DHERE CONSTANT CONUSER

USER FOLLOWER
USER TTOS
USER _R0

USER-HERE 22 CELLS + ALLOT


: LOCAL	( tid a | tid a -- a ) ( index another task's local variable )
	C_STATUS
	- ( address to offset )
	+
 ; ( offset to address )


: _PASS	( STATUS -- ) ( hilevel absolute branch )
	CELL+ \    FOLLOWER
	@ DUP @
SL\	CELL+
	>R ;

' _PASS CONSTANT PASS

: _WAKE	( STATUS -- ) ( restore follower )
	UP!  TTOS @ SP! RP!
;

' _WAKE CONSTANT WAKE


:  COR_PAUSE	( -- ) ( allow another task to execute )
	RP@ SP@ TTOS !  FOLLOWER @ DUP @
SL\	CELL+
	>R ;

: C_STOP ( -- ) ( sleep current task )
	PASS C_STATUS !  COR_PAUSE ;

: C_SLEEP	( tid -- ) ( sleep another task )
	PASS SWAP C_STATUS LOCAL ! ;

: AWAKE  	( tid -- ) ( wake another task )
	WAKE SWAP C_STATUS LOCAL ! ;

VARIABLE &_PAUSE

\S79 C_PAUSE:

: C_PAUSE &_PAUSE PERFORM ;


: ACTIVATE	( Ttid -- )
	>R
\	CONUSER R@ @ USER-HERE CMOVE
	R@  CELL+ @  _R0  R@ @ LOCAL !
	R@ 2CELL+ @  S0   R@ @ LOCAL !
	R@ 2CELL+ @  TTOS R@ @ LOCAL !
	R@  CELL+ @  R@ 2CELL+ @  !
	R> @
	R>
	OVER TTOS LOCAL @ @ !	( save sp in tos )
	AWAKE ;

: C_ACTIVATE   ( tid -- )
\	CR ." ATID=" DUP H.

                R>
                OVER	TTOS LOCAL
\	CR ." ATOS=" DUP H.
 @ @ !      ( save sp in tos )
                AWAKE ;

\ TDIS-OPT

\ initialize task tid, and put it to sleep



 0 CONSTANT UU
 400 CONSTANT SS
 2000  CONSTANT RR

USER-HERE UU + SS + RR + CONSTANT TSKsize

CREATE TSKPOOL  TSKsize 6 * ALLOT
VARIABLE TSKDP
VARIABLE &tid
:  TSKHERE TSKDP @ ;
:  TSKALLOT TSKDP +! ;

: XNEWTASK  \  { u s r \ tid size -- tid }
\          USER-HERE u + s + r + TO size
          TSKsize 16 + TSKHERE  &tid !
	  TSKALLOT 
          CONUSER &tid @ [ USER-HERE LIT, ] CMOVE
          &tid @ TSKsize +    \ RP
          DUP CELL+ _R0 &tid @  LOCAL !
          DUP     RR -   \ RP SP
          DUP  S0 &tid @ LOCAL !
          DUP TTOS &tid @ LOCAL
\	CR ." TOS=" DUP H.
 !  !
\          ['] END-PAUSE_ *END-PAUSE* tid _LOCAL !
\          ['] BIG-PAUSE_ *BIG-PAUSE* tid _LOCAL ! 
\          ['] NOOP *END-PAUSE* tid _LOCAL !
\          ['] NOOP *BIG-PAUSE* tid _LOCAL ! 
          &tid @
;

: ALSOTASK      ( tid -- )
\        @
\	DUP CONUSER =
\	IF DROP EXIT THEN			( not main task )
	DUP C_SLEEP				( sleep new task )
	FOLLOWER @ OVER FOLLOWER LOCAL !	( link new task )
	C_STATUS LOCAL FOLLOWER ! ;		( link old task )

: ONLYTASK      ( -- ) ( initialize main task )
	CONUSER DUP UP!
	C_STATUS FOLLOWER !  AWAKE ;

: MULTI		( -- )	\ enable multi-tasking
	['] COR_PAUSE &_PAUSE ! ;

: SINGLE	( -- )	\ disable multi-tasking
	['] NOOP &_PAUSE ! ;

[IFNDEF] SREGS
CREATE SREGS
3 CELLS ALLOT
[THEN]



\S79 Aforth_exec:
CODE Aforth_exec
 STMDB SP!,{R3-R12,LR}
 LDR R5, =SREGS
 LDMIA	R5,{TOS,DSTK,UP}

	mov     lr, pc
	BX R0
 
 LDR R5, =SREGS
 STMIA	R5,{TOS,DSTK,UP}
 LDMIA SP!,{R3-R12,PC}
ASM_END


CODE C_EXEC
  STR LR,[SP,#-4]!
 MOV	R0,TOS
 LDR	TOS,    [DSTK], #4
 LDR R5, =SREGS
 STMIA	R5,{TOS,DSTK,UP}
	mov     lr, pc
	BX R0
 
 LDR R5, =SREGS
 LDMIA	R5,{TOS,DSTK,UP}
  LDR PC, [SP],#4
ASM_END

CODE C_EXEC>
  STR LR,[SP,#-4]!
 MOV	R0,TOS
 LDR	TOS,    [DSTK], #4
 LDR R5, =SREGS
 STMIA	R5,{TOS,DSTK,UP}
	mov     lr, pc
	BX R0
 
 LDR R5, =SREGS
 LDMIA	R5,{TOS,DSTK,UP}
	str	TOS,[DSTK,#-4]!
	mov	tos,r0
  LDR PC, [SP],#4
ASM_END

USER &ACT

: CIACT ( cfa tid -- )
 SWAP  OVER \  tid cfa tid
 &ACT LOCAL ! C_ACTIVATE &ACT @ C_EXEC ;

[IFNDEF] TSKCFA
VARIABLE TSKCFA
[THEN]

: XCINEWTASKDO ( -- )
\  CONUSER UP@ <> IF CR ." NO CON" KEY DROP DROP DBG EXIT THEN
  TSKCFA @
 XNEWTASK DUP \ DUP >R
 \ cfa tid  tid 
 ALSOTASK  CIACT
\ R> NIP
 ;

\S79 XCINEWTASK:
CODE XCINEWTASK
	STR LR,[SP,#-4]!
	bl ' XCINEWTASKDO
	LDR R0, = &tid
	LDR R0, [R0]
	LDR PC, [SP],#4
ASM_END

\S79 IDTASK:
CODE IDTASK
	MOV	R0, UP
	NEXT
ASM_END

CODE CCPAUSE
	STR LR,[SP,#-4]!
	LDR R0, = ' C_PAUSE
	bl ' forth_exec 

	LDR PC, [SP],#4
ASM_END

