

#define AT91C_BASE_DBGU 0xFFFFF200
VARIABLE OUTMODE
: PASET 0xFFFFF430 ! ;
: PACLEAR 0xFFFFF434 ! ;

: PA!
 1 SWAP LSHIFT
 SWAP
IF PASET
ELSE PACLEAR
THEN ;


CODE OUTPUT_ ( c -- )
	ldr	TREG, = AT91C_BASE_DBGU
LL0:	ldr	r0, [TREG, #0x14]
\	tst	r0, #0x20   @ Wait for transmit data register empty flag
	tst	r0, #0x2   @ Wait for transmit data register empty flag
	beq	LL0             @   to go true.
	strb	TOS, [TREG,#0x1C]       @ Write to serial port
	ldr	TOS, [DSTK], #4 \ DROP
	NEXT
ASM_END


: YYYZZZ
;

: OUTPUT
	WDT_CHOP
\	DUP 0x80 AND
\	IF YYYZZZ
\	THEN
	OUTPUT_
;

CODE INPUT_ ( -- c )
	str TOS ,[DSTK,#-4]! \ DUP
CODL DROPINPUT
        ldr r0, = AT91C_BASE_DBGU
LL0:	ldrb	TREG,  [r0, #0x14]
        tst	TREG, #1       @ Wait for receive data ready flag
        beq	LL0             @   to go true.
        ldrb	TOS, [r0, #0x18]     @ Read character from serial port into r0
	NEXT
ASM_END

CODE LAST_INPUT
	str	TOS ,[DSTK,#-4]! \ DUP
        ldr	TOS, = AT91C_BASE_DBGU
	ldrb	TOS,  [TOS,#0x18]	@ Read character from serial port into r0
	NEXT
ASM_END

CODE INPUT? ( -- flag )
	str	TOS ,[DSTK,#-4]! \ DUP
        ldr	TREG, = AT91C_BASE_DBGU
	ldrb	TOS,  [TREG,#0x14]
        AND	TOS,TOS,#1
        rsb	TOS,TOS,#0	@ TOS := 0 - TOS (i.e. two's  complement)
	NEXT
ASM_END


: INPUT	( -- c )
	BEGIN WDT_CHOP \ C_PAUSE
 INPUT?
	UNTIL LAST_INPUT ;


: WINPUT ( -- n )
      INPUT
      INPUT    8 LSHIFT OR ;

: DINPUT ( -- n )
      WINPUT
      INPUT 0x10 LSHIFT OR
      INPUT 0x18 LSHIFT OR
;

: WOUTPUT ( w -- )
            DUP  OUTPUT
   8 RSHIFT      OUTPUT ;

: DOUTPUT ( n -- )
            DUP  OUTPUT
   8 RSHIFT DUP  OUTPUT
   8 RSHIFT     WOUTPUT  ;

: H.   ( u -- )
 #H. OUTPUT DOUTPUT ;

: U.   ( u -- )
 #U. OUTPUT DOUTPUT ;

: .   ( u -- )
 #. OUTPUT DOUTPUT ;

: _EMIT ( c -- )
 #E OUTPUT OUTPUT ;


: GTICS ( n -- )
  CountWDT @ U> IF BREAK
\  AT91C_BASE_DBGU 0x14 + C@ 2 AND IF BREAK
 #GTICS OUTPUT timecou  @ OUTPUT ;


: CR #CR OUTPUT ;

: _TICS
 timecou  @ +
	BEGIN 	DUP timecou  @  -
 0< 	UNTIL DROP ;
VARIABLE EMTIMEOUT

: EMIT ( c -- )
 OUTMODE @ IF CR OUTMODE 0! THEN
 #E OUTPUT
\ 1 _TICS
\ EMTIMEOUT W@  1 OR BEGIN WDT_CHOP 1- DUP 0= UNTIL DROP    \ 0 DO LOOP
 OUTPUT ;

: KEY   #KEY  OUTPUT INPUT ;
: KEY?  #KEY? OUTPUT INPUT ;

: TYPE ( c-addr1 u --- )
\ Output the string starting at c-addr and length u to the terminal.
   OVER + SWAP BEGIN 2DUP - WHILE DUP C@ EMIT CHAR+ REPEAT 2DROP ;

' TYPE TO 'TYPE
: HEXTYPE
  OVER + SWAP BEGIN 2DUP - WHILE DUP C@ H. CHAR+ REPEAT 2DROP ;

: TO-G   ( u -- )
 #TO-G OUTPUT DOUTPUT ;

: TO-R   ( u -- )
 #TO-R OUTPUT DOUTPUT ;

: TO-B   ( u -- )
 #TO-B OUTPUT DOUTPUT ;

: TAB 9 EMIT ;

: HWINIT
EXTPGPS_ON
\ EXTPGSM_ON
CHARG_OFF
POWER_ACC_ON

;

: UNHWINIT

EXTPGSM_OFF
EXTPGPS_OFF
CHARG_ON
POWER_ACC_OFF
\ 
\ GPS_MRST_ON
\ 0x2FFFFF BEGIN 1- DUP 0= UNTIL DROP

;

: GPS_SW_ON
 EXTPGPS_ON
( GPS_MRST_OFF
 1 SECS
 GPS_MRST_ON
 PA15_GPS_OFF )
;

: GPS_SW_OFF
  EXTPGPS_OFF
\  PA15_GPS_ON
;


: GPS_INIT GPS_SW_ON ;

CODE PEMIT
	STMDB	SP!,{LR}
	MOV	r0, TOS 
	BL	' CPEMIT
	ldr	TOS, [DSTK], #4  \ DROP
	LDMIA	SP!,{LR}
	NEXT
ASM_END

CODE PINPUT?
	STMDB	SP!,{LR}
	str	TOS, [DSTK,#-4]! \ DUP
	BL	' ComCnt0
	MOV	TOS, r0
	LDMIA	SP!,{LR}
	NEXT
ASM_END

CODE _PINPUT
	STMDB	SP!,{LR}
	str	TOS, [DSTK,#-4]! \ DUP
	BL	' GetPort0
	MOV	TOS, r0
	LDMIA	SP!,{LR}
	NEXT
ASM_END

VARIABLE ?PINPUT.

: PINPUT
 _PINPUT
 ?PINPUT. @
 IF OUTMODE @ 2 <> IF CR ." GPS>" 2 OUTMODE ! THEN
    DUP _EMIT
 THEN
 ;

: .GPS
 BEGIN PINPUT? \ WDT_CHOP
 WHILE PINPUT _EMIT REPEAT ;

0 [IF]
CODE ADC5@
	STMDB	SP!,{LR}
	str	TOS, [DSTK,#-4]! \ DUP
	BL	' ADC5
	MOV	TOS, r0
	LDMIA	SP!,{LR}
	NEXT
ASM_END

CODE ADC6@
	STMDB	SP!,{LR}
	str	TOS, [DSTK,#-4]! \ DUP
	BL	' ADC6
	MOV	TOS, r0
	LDMIA	SP!,{LR}
	NEXT
ASM_END

[THEN]

: ADC5@ DATA5 @ ;
: ADC6@ DATA6 @ ;
: ADC7@ DATA7 @ ;


\ http://www.gaw.ru/html.cgi/txt/doc/micros/arm/arh_sam7s/27_2.htm