\ Assembler for ARM7TDMI

REQUIRE [IF] ~MAK\CompIF1.f
REQUIRE [IFNDEF] ~nn\lib\ifdef.f
REQUIRE NUMBER? ~mak\LIB\fpcnum.f

[IFNDEF] <<	: << LSHIFT ;	[THEN]
[IFNDEF] >>	: >> RSHIFT ;	[THEN]
[IFNDEF] BREAK	: BREAK  POSTPONE EXIT POSTPONE THEN ; IMMEDIATE [THEN]
[IFNDEF] CELL/	: CELL/  CELL / ;	[THEN]
[IFNDEF] OR!	:  OR! ( N ADDR -- )	DUP @ ROT OR	SWAP ! ; [THEN]
[IFNDEF] AND!	: AND! ( N ADDR -- )	DUP @ ROT AND	SWAP ! ; [THEN]
[IFNDEF] USHORT? : USHORT? ( n -- -129<n<256 )  0x80 +  0x180 U< ; [THEN]
[IFNDEF] NOT	: NOT INVERT ; [THEN]
[IFNDEF] FF_ALIGN
: FF_ALIGN
	BEGIN HERE 3 AND 
	WHILE 0xFF C,
	REPEAT ;
[THEN]

0 VALUE ASMDBG

MODULE: ASMARM_MOD

0xE VALUE COND

: INVERT-CC ( cc -- cc ) COND  1 XOR TO COND ;
: COND-CC ( n <name> ) CREATE , DOES> @ TO COND ;
: COND@ ( opc1 -- opc2 )
 COND
 28 << 
+ 
0xE TO COND
;

\ enumerated condition codes
0x0 COND-CC EQ               \ equal or zero
0x1 COND-CC NE               \ not equal
0x2 COND-CC CS               \ carry set
0x3 COND-CC CC               \ carry clear
0x2 COND-CC HS               \ higher or same (unsigned)
0x3 COND-CC LO               \ lower (unsigned)
0x4 COND-CC MI               \ minus or negative
0x5 COND-CC PL               \ zero or positive
0x6 COND-CC VS               \ overflow set
0x7 COND-CC VC               \ overflow clear
0x8 COND-CC HI               \ higher (unsigned)
0x9 COND-CC LS               \ lower or same (unsigned)
0xA COND-CC GE               \ greater then or equal (signed)
0xB COND-CC LT               \ less than (signed)
0xC COND-CC GT               \ greter than (signed)
0xD COND-CC LE               \ less then or equal (signed)

: ENUM DUP CONSTANT 1+ ;

0 ENUM R0  ENUM R1  ENUM R2  ENUM R3
  ENUM R4  ENUM R5  ENUM R6  ENUM R7
  ENUM R8  ENUM R9  ENUM R10 ENUM R11
  ENUM R12
DUP
  ENUM R13 ENUM R14 ENUM R15 DROP
  ENUM SP  ENUM LR  ENUM PC  DROP

-15
  ENUM -R15 ENUM -R14 ENUM -R13 ENUM -R12
  ENUM -R11 ENUM -R10 ENUM -R9  ENUM -R8
  ENUM -R7  ENUM -R6  ENUM -R5  ENUM -R4
  ENUM -R3  ENUM -R2  ENUM -R1
DROP

0 ENUM CR0   ENUM CR1  ENUM CR2  ENUM CR3
  ENUM CR4   ENUM CR5  ENUM CR6  ENUM CR7
  ENUM CR8   ENUM CR9  ENUM CR10 ENUM CR11
  ENUM CR12  ENUM CR13 ENUM CR14 ENUM CR15 DROP


\ immediate and status register bit
0 VALUE #I
0 VALUE SR

\ set the status update bit
: S!  1 20 <<   TO SR ;
: S@ SR OR 0 TO SR ;

\ rotate a bits left

 : ROTATE DUP 30 >> SWAP 2 << + ;

\ set and use the immediate bit for an opcode
: #! 1 25 <<  TO #I ;
: #@ #I + 0 TO #I ;

\ test if an immediate value is 8-bit rotatable

: U8-BIT? ( n -- n flag )
  DUP >R 0 BEGIN OVER USHORT? 0= \  0xFF U>
 WHILE
  SWAP ROTATE SWAP 1+ DUP 15 >
  IF 2DROP R> 0 BREAK
  REPEAT 2DROP R> TRUE ;

: 8-BIT? ( n -- n flag )
  DUP >R 0 BEGIN OVER 0xFF U>
 WHILE
  SWAP ROTATE SWAP 1+ DUP 15 >
  IF 2DROP R> 0 BREAK
  REPEAT 2DROP R> TRUE ;

0 VALUE VSP@
0 VALUE []
0 VALUE ?##
0 VALUE BBF
0 VALUE HHF
0 VALUE :=F
0 VALUE !!F
0 VALUE SHF

: [[    SP@ TO VSP@ ;

: DO_SH
  SHF IF
 0x1F AND 7 <<
  ?## 0= IF 1 << 10H OR THEN
   OR
 0 TO ?##
 0 TO SHF
 THEN ;

: ]]
  DO_SH
 VSP@ SP@  - CELL/ 2-
 DUP -2 AND IF -333 THROW THEN
\ f7_ed
  24 LSHIFT  TO []  ;

: !! 0x00200000  \ writ-back bit
    TO !!F ;

: ## TRUE TO ?## ;

: BB  \ byte address
 0x00400000 TO BBF ;

\ create a rotated, immediate value
: ### ( n -- opc )
\	F7_ED
	?##
	IF 0 TO ?## 0
		BEGIN  OVER  USHORT? 0= \ 0xFF U>
		WHILE 	SWAP ROTATE SWAP  1+  DUP 15 >
			IF ." INVALID IMMEDIATE OPERAND" ABORT THEN
		REPEAT  8 <<  +  #!
	THEN
;

\ immediately rotated register class
: SHIFT-OP ( n <name> -- ) CREATE , DOES> ( reg n -- opc ) @  OR TRUE TO SHF ;

\ some register shift operators
0x00 SHIFT-OP LSL          \ logical shift left
0x20 SHIFT-OP LSR          \ logical shift right
0x40 SHIFT-OP ASR          \ arithemetic shift right
0x60 SHIFT-OP ROR          \ rotate right
: RRX ROR ## 32 ;

0 VALUE ADR_MOD

\ stack operator class
: STACK-OP ( n <name> -- ) CREATE , DOES> ( rm -- opc -1 ) @ TO  ADR_MOD  ;

\ stack operators
0x00000000 STACK-OP DA      \ decrement after
0x01000000 STACK-OP DB      \ derement before
0x00800000 STACK-OP IA      \ increment after
0x01800000 STACK-OP IB      \ increment before

0x00000000 STACK-OP FA      \ decrement after
0x01000000 STACK-OP EA      \ derement before
0x00800000 STACK-OP FD      \ increment after
0x01800000 STACK-OP ED      \ increment before

\ compile the opcode into the meta output
: OP, ( opc -- )
 #@  S@  COND@  ,  ;

\ alu class instruction
: ALU ( n <name> -- ) CREATE , DOES> ( opc rn rd -- )
	@ >R DO_SH ###
	SWAP 16 << OR
	SWAP 12 << OR
	R> OR OP, ;

\ alu instructions

0x00000000 ALU AND,          \ bitwise and
0x00200000 ALU EOR,          \ exclusive or
0x00400000 ALU SUB,          \ subtract
0x00600000 ALU RSB,          \ reverse subtract
0x00800000 ALU ADD,          \ add
0x00A00000 ALU ADC,          \ add with carry
0x00C00000 ALU SBC,          \ subtract with borrow
0x00E00000 ALU RSC,          \ reverse subtract with borrow
0x01800000 ALU ORR,          \ bitwise or
0x01C00000 ALU BIC,          \ bit clear

\ move class instructions
: ALU2 ( n <name> -- ) CREATE , DOES> ( opc rd \ rn rd -- )
 @ >R \ F7_ED
 DO_SH ###
 R>  +
 SWAP 12 << +
 OP, ;

\ move instructions
0x01A00000 ALU2 MOV,         \ move into register
0x01E00000 ALU2 MVN,         \ move bitwise not into register

\ compare class instructions
: ALU3 ( n <name> -- ) CREATE , DOES> ( opc rd \ rn rd -- )
 @ >R DO_SH ### R> + SWAP 16 << +
 OP,
 ;

\ compare and test instructions
0x01700000 ALU3 CMN,         \ compare bitwise not
0x01500000 ALU3 CMP,         \ compare
0x01300000 ALU3 TEQ,         \ test bits
0x01100000 ALU3 TST,         \ test bits


:  $FORWARD@  ( id_addr tab -- link )
    +
   0xFFFFFFFE AND  \   
   { addr -- link }
   addr @ DUP
   IF HERE - NEGATE
   THEN
   HERE addr
  !
;

0 VALUE $FORWARD24
0 VALUE $BACK

:  ITC>ORESOLVE24  { Jaddr Haddr -- }
           0xFF000000 Jaddr AND!  \    disp24
           Haddr Jaddr - CELL/ 2- 0x00FFFFFF AND
             Jaddr OR!                  \  disp24
;

:   $FORWARD24!  ( id_addr  -- )
    $FORWARD24 + DUP
 @ 
 { addr --  }
   BEGIN addr
   WHILE addr @
         addr HERE ITC>ORESOLVE24

\   

         0x00FFFFFF AND   DUP
         IF   addr  - NEGATE
         THEN TO addr 
   REPEAT  0!
;

: LTABLE@      ( n --- )               \  
   CREATE ,
   DOES> @ \ F7_ED
   DUP $BACK +  @ ?DUP
   IF 1- NIP   EXIT
   THEN
   1 OR  \  LTABLE
;

: LTABLE!      ( n --- )               \  
   CREATE ,
   DOES> @  \ F7_ED
     DUP  $BACK + @ ABORT" Label redefinition!"
     HERE 1+ OVER  $BACK  +  !
     $FORWARD24!
;

: ::$   DUP  LTABLE@ DUP LTABLE! CELL+ ;

0
::$  LL0 LL0:
::$  LL1 LL1:
::$  LL2 LL2:
::$  LL3 LL3:
::$  LL4 LL4:
::$  LL5 LL5:
::$  LL6 LL6:
::$  LL7 LL7:
::$  LL8 LL8:
::$  LL9 LL9:

::$  LL10 LL10:
::$  LL11 LL11:
::$  LL12 LL12:
::$  LL13 LL13:
::$  LL14 LL14:
::$  LL15 LL15:
::$  LL16 LL16:
::$  LL17 LL17:
::$  LL18 LL18:
::$  LL19 LL19:

::$  LL20 LL20:
::$  LL21 LL21:
::$  LL22 LL22:
::$  LL23 LL23:
::$  LL24 LL24:
::$  LL25 LL25:
::$  LL26 LL26:
::$  LL27 LL27:
::$  LL28 LL28:
::$  LL29 LL29:

 DUP VALUE $COUNT@
50 CELLS +
CONSTANT $BUFF_SIZE

: $COUNT! DUP $BUFF_SIZE U< 0=
  ABORT" number of label name limit has reached!"
  TO $COUNT@ ;

4 HERE 3 AND - ALLOT

HERE TO $FORWARD24 $BUFF_SIZE ALLOT
HERE TO $BACK      $BUFF_SIZE ALLOT

: $_INIT \     
 $FORWARD24 $BACK OVER -  $BUFF_SIZE + ERASE ;

\ calculate the offset for a branch
: #OFFSET ( to from -- n )
 8 + -
 DUP ABS 0xFC000000 AND IF -314 THROW THEN
 2 >>	0xFFFFFF AND ;

\ branch instruction class
: BRANCH: ( n <name> -- ) CREATE , DOES> ( a -- ) >R
	DUP 1 AND
	IF	$FORWARD24 $FORWARD@
	ELSE	HERE #OFFSET
	THEN	R> @ + OP, ;

\ branch and branch with link
0x0A000000 BRANCH: B,
0x0B000000 BRANCH: BL,

: BEQ, EQ  B, ; \ equal or zero
: BNE, NE  B, ; \ not equal
: BCS, CS  B, ; \ carry set
: BCC, CC  B, ; \ carry clear
: BHS, HS  B, ; \ higher or same (unsigned)
: BLO, LO  B, ; \ lower (unsigned)
: BMI, MI  B, ; \ minus or negative
: BPL, PL  B, ; \ zero or positive
: BVS, VS  B, ; \ overflow set
: BVC, VC  B, ; \ overflow clear
: BHI, HI  B, ; \ higher (unsigned)
: BLS, LS  B, ; \ lower or same (unsigned)
: BGE, GE  B, ; \ greater then or equal (signed)
: BLT, LT  B, ; \ less than (signed)
: BGT, GT  B, ; \ greter than (signed)
: BLE, LE  B, ; \ less then or equal (signed)

: BLEQ, EQ  BL, ; \ equal or zero
: BLNE, NE  BL, ; \ not equal
: BLCS, CS  BL, ; \ carry set
: BLCC, CC  BL, ; \ carry clear
: BLHS, HS  BL, ; \ higher or same (unsigned)
: BLLO, LO  BL, ; \ lower (unsigned)
: BLMI, MI  BL, ; \ minus or negative
: BLPL, PL  BL, ; \ zero or positive
: BLVS, VS  BL, ; \ overflow set
: BLVC, VC  BL, ; \ overflow clear
: BLHI, HI  BL, ; \ higher (unsigned)
: BLLS, LS  BL, ; \ lower or same (unsigned)
: BLGE, GE  BL, ; \ greater then or equal (signed)
: BLLT, LT  BL, ; \ less than (signed)
: BLGT, GT  BL, ; \ greter than (signed)
: BLLE, LE  BL, ; \ less then or equal (signed)

: BX, 0x012FFF10 + OP, ;        \ branch and exchange

: BXEQ, EQ  BX, ; \ equal or zero
: BXNE, NE  BX, ; \ not equal
: BXCS, CS  BX, ; \ carry set
: BXCC, CC  BX, ; \ carry clear
: BXHS, HS  BX, ; \ higher or same (unsigned)
: BXLO, LO  BX, ; \ lower (unsigned)
: BXMI, MI  BX, ; \ minus or negative
: BXPL, PL  BX, ; \ zero or positive
: BXVS, VS  BX, ; \ overflow set
: BXVC, VC  BX, ; \ overflow clear
: BXHI, HI  BX, ; \ higher (unsigned)
: BXLS, LS  BX, ; \ lower or same (unsigned)
: BXGE, GE  BX, ; \ greater then or equal (signed)
: BXLT, LT  BX, ; \ less than (signed)
: BXGT, GT  BX, ; \ greter than (signed)
: BXLE, LE  BX, ; \ less then or equal (signed)

\ multiply
: MUL, ( rs rm rd -- )  8 << ROT 16 << 0x90 + + + OP, ;

TRUE VALUE $$^^

\ extended multiply class
: EX-MUL ( n <name> -- )
CREATE , DOES> ( rs rm rdhi rdlo -- )
 >R  8 << + SWAP 16 << + SWAP 12 << + R>  @ +  OP, ;

0x00E00090 EX-MUL SMLAL,     \ signed extended multiply
0x00C00090 EX-MUL SMULL,     \ signed extended multiply
0x00A00090 EX-MUL UMLAL,     \ unsigned extended multiply
0x00800090 EX-MUL UMULL,     \ unsigned extended multiply

\ software interrupt
: SWI, ( n -- ) DUP 0xFF > IF ." unknown interrupt" ABORT THEN
16 << 0x0F000000 + OP, ;

\ memory swap class

: SWP, ( rn rm rd -- )
	16 << OR
	SWAP 12 << OR
	BBF	OR 0 TO BBF
	0x01000090 OR
 OP, ;

\ address at register
: 0@ ( rn -- opc ) 16 << ;

\ sets the decrement bit for an immediate offset
: -IMM ( n1 -- n2 )
 DUP
 ABS
 SWAP 0 < 0=
 IF 0x00800000 + THEN
 ;

\ exchange nibbles of a halfword, byte offset
: /IMM ( n -- n ) DUP 0xF0 NOT AND SWAP 0xF0 AND 4 << + ;

\ load and store halfword address class

  : HH  0x040000B0 TO HHF ;
  : BB  0x0400000 TO BBF ;
  : SH  0x40 TO SR HH ;
  : SB  0x40 TO SR BB ;
  : ACTION = IF /IMM 0x00400000 + BREAK 0x02000000 XOR ;
  : HHH HHF IF  SWAP DUP 0x02000000 AND 0 ACTION THEN ;
  : :=  TRUE TO :=F  [[ PC ## 0 ]] ;

0 VALUE :=COUNT
CREATE :=COUNT0 22 2* CELLS ALLOT
HERE 0 DUP , ,

 CONSTANT MAX:=COUNT

\ load and store register address class

: REG-ADDR ( n <name> -- ) CREATE , DOES> ( opc rd -- )
 @ >R \ F7_ED
\ DUP ABS
\ 0xFFFFFF00 AND :=F 0= AND
\ IF -333 THROW THEN
  :=F
	IF 0 TO :=F HERE :=COUNT 2!
		:=COUNT CELL+ CELL+ DUP MAX:=COUNT
		U< 0= ABORT" excess ="
		TO :=COUNT
	THEN \ F7_ED
	VSP@ SP@  - 8 =  [] 0= AND IF 0 TRUE TO ?## 1 24 LSHIFT TO []  THEN
	
	-IMM
  ?##	IF 0 TO ?##  0x02000000 OR
	THEN 0x02000000 XOR
	SWAP 16 << OR
	SWAP 12 << HHH OR  R>  OR
	[]	OR 0 TO []
	!!F	OR 0 TO !!F
	BBF	OR 0 TO BBF
	HHF	XOR 0 TO HHF
OP, ;

0x04100000 REG-ADDR LDR,     \ load word-aligned address
0x04000000 REG-ADDR STR,     \ store word-aligned address


: SWP, ( rn rm rd -- )
	16 << OR
	SWAP 12 << OR
	BBF	OR 0 TO BBF
	0x01000090 OR
 OP, ;


: MCRRC,
\	F7_ED
	SWAP
	5	<< OR OR SWAP
	16	<< OR SWAP
	12	<< OR SWAP
	21	<< OR SWAP
	8	<< OR
 OP,
	
;

: MRC{, 0x0E100010 MCRRC, ;
: MCR{, 0x0E000010 MCRRC, ;
: MRC, MRC{, ;
: MCR, MCR{, ;


: }}    
	0
	BEGIN OVER -16 >
	WHILE OVER 0< IF \ F7_ED
			>R OVER 0< IF -333 THROW THEN
			NEGATE 2DUP < IF SWAP THEN
			OVER SWAP
			R> -ROT
			?DO 1 I << OR LOOP
		THEN	1 ROT << OR
	REPEAT
 NIP ;

: {{ -1000 ;

\ stack instruction class
: STM,  ( Rn {}  -- ) \ store multiple registers
	SWAP 16 <<
	0x08000000  OR OR
	ASMDBG IF ." X1=" .S THEN
	ADR_MOD OR
	!!F	OR 0 TO !!F
	ASMDBG IF ." X2=" .S THEN
	OP, ;

: LDM,  ( n n1  -- ) \ load multiple registers
   0x00100000 OR STM, ;

0x21 CONSTANT CPSR_C
0x22 CONSTANT CPSR_X
0x24 CONSTANT CPSR_S
0x28 CONSTANT CPSR_F
0x29 CONSTANT CPSR_CF
0x29 CONSTANT CPSR
0x61 CONSTANT SPSR_C
0x62 CONSTANT SPSR_X
0x64 CONSTANT SPSR_S
0x68 CONSTANT SPSR_F
0x69 CONSTANT SPSR_CF
0x69 CONSTANT SPSR

: MSR, ### SWAP 16 << OR 0x0100F000 OR OP, ;
: MRS, ### 0x40 AND 16 << SWAP 12 << OR 0x010F0000 OR OP, ;

: SMLABB,  12 << SWAP 8 << OR OR  SWAP 16 << OR OP, ;

\ return from subroutine macro and no-op
: RET, LR BX, ;

\ reserve address for FORWARD branch
: AHEAD, HERE DUP B, ;
: RESOLVE OVER @ 0xFE000000 AND + SWAP ! ;

\ conditional branch macros
: IF,    ( cc -- a ) INVERT-CC AHEAD, ;
: THEN,  ( a -- )
\ F7_ED
 HERE
 OVER
 #OFFSET
 RESOLVE ;
: ELSE,  ( a -- a ) AHEAD, SWAP THEN, ;

\ loop macros
: BEGIN,  HERE ;
: UNTIL,  INVERT-CC B, ;
: AGAIN,  B, ;

\ conditional entry loops
: WHILE,  IF, SWAP ;
: REPEAT, AGAIN, THEN, ;

VARIABLE NLASTS NLASTS 0!

: CODL
	FF_ALIGN
[IFDEF] TEXEC_BUF
	>IN M@ >R
	PARSE-NAME
\ 	ALSO FORTH
 SFIND
\ PREVIOUS

	IF	TEXEC_BUF TEXEC_BUF CELL+ TEB_SIZE MOVE
		TEXEC_KEY TEXEC_KEY CELL+ TEB_SIZE MOVE
			TEXEC_BUF !
		HERE	TEXEC_KEY !
	ELSE	2DROP
	THEN

	R> >IN M!
[THEN] 
	HEADER

        NLASTS 1+!
;

VECT A?HEAD

' NOOP TO A?HEAD

: ASM_END
	PREVIOUS
	0
	$BACK  $FORWARD24
	DO  I @ OR
CELL	+LOOP  ABORT" Unresolved reference!"
	:=COUNT	:=COUNT0
	?DO  I CELL+ @ , HERE I @ - 12 - I @ OR! 
8	+LOOP

	LAST @ NLASTS @
	BEGIN  DUP
	WHILE A?HEAD LAST @ CDR LAST ! 1-
	REPEAT NLASTS !
	LAST !
;

EXPORT

: ASM_BIG
	FF_ALIGN
	ALSO ASMARM_MOD
	$_INIT
	:=COUNT0 TO  :=COUNT ;

: CODE
 CODL
 ASM_BIG ;

;MODULE
' ASMARM_MOD H.


