
: (?DO)  ( n1 n2 ---)
\ Runtime part of ?DO
   2DUP - IF R> -ROT SWAP >R >R CELL+ 
                  ELSE 2DROP R> @ \ Jump to leave address if equal
                  THEN  >R ;

: (LOOP) ( ---)
\ Runtime part of LOOP
  R> R> 1+ DUP R@ =   \ Add 1 to count and compare to limit.
  IF   R> 2DROP CELL+ \ Discard parameters and skip leave address.
  ELSE  >R DUP @ + \ Repush counter and jump to loop start address.
  THEN  >R ;

: (+LOOP) ( n ---)
\ Runtime part of +LOOP
\ Very similar to (LOOP), but the compare condition is different.
\  exit if ( oldcount - lim < 0) xor ( newcount - lim < 0).
     R>SWAP R> DUP R@ - -ROT + DUP R@ - ROT XOR 0<
     IF R> 2DROP CELL+
     ELSE  >R DUP @ + THEN  >R ;

: J  ( --- n)
\ Return the counter (index) of the next loop outer to the innermost DO LOOP
  RP@ 12 + @ ;

: (LEAVE)   ( --- )
\ Runtime part of LEAVE
  R> @ 2RDROP >R ; \ Remove loop parameters and replace top of ret
                            \ stack by leave address.
\EOF

: (DO)   ( n1 n2 ---)
\ Runtime part of DO.
  R> -ROT SWAP >R >R >R ;

: I ( --- n )
\ Return the counter (index) of the innermost DO LOOP
     R> R@ SWAP >R ;

: UNLOOP ( --- )
\ Remove one set of loop parameters from the return stack.
   R> 2RDROP >R ;
                        
